/*
** Graph.c
** 
** Made by (Johnny Q. Hacker)
** Login   <solarion@johnathan>
** 


    Copyright (C) 2008 Joseph Pingenot

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU Affero General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Affero General Public License for more details.

    You should have received a copy of the GNU Affero General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.


**Many thanks to Davyd Madeley for the excellent Cairo  Tutorial
**  at http://gnomejournal.org/article/34/writing-a--using-cairo-and-gtk28

** Started on  Thu Jul 17 10:51:32 2008 Johnny Q. Hacker
** Last update Sun May 12 01:17:25 2002 Speed Blue
*/

#include <graph.h>
#include <stdlib.h>

G_DEFINE_TYPE(Graph, graph, G_TYPE_OBJECT);

static void graph_class_init(GraphClass *klass) {
  GObjectClass *gobject_klass;
  gobject_klass = G_OBJECT_CLASS(klass);
}

static void graph_init(Graph *graph) {
  graph->symbol = CIRCLE;
  graph->points = g_ptr_array_new();
}

Graph *graph_new(void) {
  return g_object_new(GRAPH_TYPE, NULL);
}

int graph_add_point(Graph* graph, double x, double y) {
  double *point = (double*)malloc(2*sizeof(double));
  if(point == NULL) return 1;
  point[0] = x;
  point[1] = y;
  g_ptr_array_add(graph->points, (gpointer)point);
  if(graph->points->len == 1) {
    graph->maxx = graph->minx = x;
    graph->maxy = graph->miny = y;
  }else{
    if(x > graph->maxx) graph->maxx = x;
    if(x < graph->minx) graph->minx = x;
    if(y > graph->maxy) graph->maxy = y;
    if(y < graph->miny) graph->miny = y;
  }
  return 0;
}
